/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Main.java to edit this template
 */
package farmarliskahusazrni;

import java.util.*;

/**
 *
 * @author Dana Nejedlová <dana.nejedlova@tul.cz>
 */
public class FarmarLiskaHusaZrni {
    
    private static final EnumSet<Ucastnik> levyBreh = EnumSet.allOf(Ucastnik.class); // https://www.baeldung.com/java-enumset  
    private static final EnumSet<Ucastnik> cilovyBreh = EnumSet.complementOf(levyBreh); // Konstatntní je místo v paměti ale ne jeho obsah.
    private static EnumSet<Ucastnik> aktualniBreh; // Břeh, na kterém je farmář. Přes tuto referenční proměnnou se mění obsah levého nebo cílového břehu.
    private static EnumSet<Ucastnik> neaktualniBreh; // Přes tuto referenční proměnnou se mění obsah levého nebo cílového břehu.
    private static Ucastnik vybranyUcastnik;
    private final static Scanner scanner = new Scanner(System.in);
    private static boolean vyhra = false;
    private static boolean prohra = false;
    
    public static void main(String[] args) {
        int pocetKroku = 0;
        uvod();
        while (!vyhra && !prohra) {
            pocetKroku++;
            vypisBrehy(pocetKroku);
            presunNaDruhyBreh();
            vyhodnotTah(pocetKroku);
        }
    }
    
    public static void uvod() {
        System.out.println(capitalizeTheFirstLetter(Ucastnik.FARMAR.getNazev()) + ", " + Ucastnik.LISKA.getNazev() + ", " + Ucastnik.HUSA.getNazev() + " a " + Ucastnik.ZRNI.getNazev());
        System.out.print(capitalizeTheFirstLetter(Ucastnik.FARMAR.getNazev()) + " chce sebe, stříbrnou " + Ucastnik.LISKA.getNazev4Pad() + ", " + Ucastnik.HUSA.getNazev4Pad());
        System.out.println(" a " + Ucastnik.ZRNI.getNazev4Pad() + " přepravit přes řeku z levého břehu na pravý břeh.");
        System.out.println("Bohužel jeho člun je tak malý, že může s sebou do něj vzít jen jednu položku ze svého majetku.");
        System.out.print("Ještě horší je to, že nehlídaná " + Ucastnik.HUSA.getNazev() + " sní " + Ucastnik.ZRNI.getNazev());
        System.out.println(" a nehlídaná " + Ucastnik.LISKA.getNazev() + " sní " + Ucastnik.HUSA.getNazev4Pad() + ",");
        System.out.print("takže " + Ucastnik.FARMAR.getNazev() + " nesmí nechat " + Ucastnik.HUSA.getNazev4Pad() + " o samotě se " + Ucastnik.ZRNI.getNazev7Pad());
        System.out.println(" nebo " + Ucastnik.LISKA.getNazev4Pad() + " o samotě s " + Ucastnik.HUSA.getNazev7Pad() + ".");
        System.out.println("Jak se to dá vyřešit?");
    }
    
    public static void vypisBrehy(int pocetKroku) {
        if (pocetKroku % 2 == 1) {
            System.out.print("Na levém břehu je ");
            aktualniBreh = levyBreh;
            neaktualniBreh = cilovyBreh;
        } else {
            System.out.print("Na pravém břehu je ");
            aktualniBreh = cilovyBreh;
            neaktualniBreh = levyBreh;
        }
        //System.out.println(aktualniBreh.toString());
        for (Ucastnik u : aktualniBreh) {
            System.out.print(u.getNazev() + ", ");
        }
        System.out.print("\b\b.\n");
    }
    
    public static void presunNaDruhyBreh() {
        int volba;
        boolean presunJeKorektni;
        vypisMoznosti();
        do {
            volba = zadejCeleCislo("Zadej číslo toho, co má " + Ucastnik.FARMAR.getNazev() + " převézt přes řeku: ");
            presunJeKorektni = testVolby(volba);
            if (!presunJeKorektni) {
                System.out.println("Tato volba není platná.");
            }
        } while (!presunJeKorektni);
        if (vybranyUcastnik != Ucastnik.FARMAR) {
            aktualniBreh.remove(vybranyUcastnik);
        }
        aktualniBreh.remove(Ucastnik.FARMAR); // Farmáš jede vždycky.
        neaktualniBreh.clear();
        neaktualniBreh.addAll(EnumSet.complementOf(aktualniBreh));
    }
    
    public static void vypisMoznosti() {
        for (Ucastnik u : aktualniBreh) {
            System.out.println(u.ordinal() + " " + u.getNazev());
        }
    }
    
    public static boolean testVolby(int volba) {
        boolean volbaJeKorektni = false;
        for (Ucastnik u : aktualniBreh) {
            if (volba == u.ordinal()) {
                volbaJeKorektni = true;
                vybranyUcastnik = u;
                break;
            }
        }
        return volbaJeKorektni;
    }
    
    public static void vyhodnotTah(int pocetKroku) {
        vyhra = cilovyBreh.containsAll(EnumSet.allOf(Ucastnik.class));
        if (vyhra) {
            System.out.println("Úspěšně jsi vyřešil hlavolam!\nBlahopřeju!");
            System.out.println("Povedlo se ti to pomocí " + pocetKroku + " přejezdů řeky.");
            return;
        }
        if (!levyBreh.contains(Ucastnik.FARMAR) && levyBreh.contains(Ucastnik.HUSA) && levyBreh.contains(Ucastnik.ZRNI)) {
            System.out.println(capitalizeTheFirstLetter(Ucastnik.HUSA.getNazev()) + " na levém břehu sežrala " + Ucastnik.ZRNI.getNazev4Pad() + "!");
            prohra = true;
        }
        if (!levyBreh.contains(Ucastnik.FARMAR) && levyBreh.contains(Ucastnik.LISKA) && levyBreh.contains(Ucastnik.HUSA)) {
            System.out.println(capitalizeTheFirstLetter(Ucastnik.LISKA.getNazev()) + " na levém břehu sežrala " + Ucastnik.HUSA.getNazev4Pad() + "!");
            prohra = true;
        }
        if (!cilovyBreh.contains(Ucastnik.FARMAR) && cilovyBreh.contains(Ucastnik.HUSA) && cilovyBreh.contains(Ucastnik.ZRNI)) {
            System.out.println(capitalizeTheFirstLetter(Ucastnik.HUSA.getNazev()) + " na pravém břehu sežrala " + Ucastnik.ZRNI.getNazev4Pad() + "!");
            prohra = true;
        }
        if (!cilovyBreh.contains(Ucastnik.FARMAR) && cilovyBreh.contains(Ucastnik.LISKA) && cilovyBreh.contains(Ucastnik.HUSA)) {
            System.out.println(capitalizeTheFirstLetter(Ucastnik.LISKA.getNazev()) + " na pravém břehu sežrala " + Ucastnik.HUSA.getNazev4Pad() + "!");
            prohra = true;
        }
    }
    
    public static String capitalizeTheFirstLetter(String slovo) {
        return slovo.substring(0,1).toUpperCase() + slovo.substring(1).toLowerCase();
    }
    
    public static int zadejCeleCislo(String vyzva) {
        int cislo;
        while (true) {
            try {
                System.out.print(vyzva);
                cislo = scanner.nextInt();
                scanner.nextLine();
                break;
            } catch (InputMismatchException e) {
                System.out.println("To není celé číslo!");
                scanner.nextLine();
            }
        }
        return cislo;
    }

}
